﻿Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite
Imports ThinkGeo.MapSuite.Wpf
Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles
Imports ThinkGeo.MapSuite.Layers
Imports System.Text

Class MainWindow
    Private Sub Window_Loaded(sender As Object, e As RoutedEventArgs)
        map1.MapUnit = GeographyUnit.DecimalDegree
        Dim inm = New InMemoryFeatureLayer
        inm.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = New PxPointStyle
        inm.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = New PxTextStyle("", "VehicleImage", 0, 10, True, New GeoSolidBrush(GeoColors.Black))
        inm.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

        Dim f As New Feature(New PointShape(0, 0))
        Dim sb As New StringBuilder
        sb.AppendLine("EKA 5124")
        sb.AppendLine("05/12/2017 12:14")


        f.ColumnValues.Add("VehicleImage", sb.ToString)

        inm.InternalFeatures.Add(f)

        Dim o As New LayerOverlay
        o.Layers.Add(inm)
        map1.Overlays.Add(o)

        inm.Open()
        map1.CurrentExtent = inm.GetBoundingBox

        map1.Refresh()
    End Sub
End Class


Public Class PxPointStyle
    Inherits PointStyle

    Dim iconpath As String

    Public Sub New()
        MyBase.New()
    End Sub

    'Protected Overrides Function GetRequiredColumnNamesCore() As Collection(Of String)
    '    Dim columns As Collection(Of String) = New Collection(Of String)()
    '    columns.Add("VehicleImage")
    '    Return columns
    'End Function

    Protected Overrides Sub DrawCore(ByVal features As IEnumerable(Of Feature), ByVal canvas As GeoCanvas, ByVal labelsInThisLayer As Collection(Of SimpleCandidate), ByVal labelsInAllLayers As Collection(Of SimpleCandidate))
        For Each feature As Feature In features
            'Dim vehicleImagePath As String = feature.ColumnValues("VehicleImage")
            Dim location As PointShape = CType(feature.GetShape(), PointShape)
            canvas.DrawWorldImageWithoutScaling(New GeoImage("..\..\MapData\car.png"), location.X, location.Y, DrawingLevel.LevelFour, 0, 0, 0)
        Next
    End Sub
End Class

Public Class PxTextStyle
    Inherits TextStyle

    Dim areastyle As Boolean
    Dim Type As String

    Public Sub New(type As String, column As String, xoffset As Integer, yoffset As Integer, areastyle As Boolean, color As GeoSolidBrush)
        Me.Type = type
        Me.areastyle = areastyle
        Me.TextColumnName = column
        Me.Font = New GeoFont("Arial ", 7.5, DrawingFontStyles.Bold)
        Me.TextSolidBrush = color
        Me.XOffsetInPixel = xoffset
        Me.YOffsetInPixel = yoffset
        Me.Mask = OnCreateMask()
        Me.Mask.DrawingLevel = Drawing.DrawingLevel.LabelLevel
        Me.MaskType = ThinkGeo.MapSuite.Styles.MaskType.RoundedCorners
        Me.DuplicateRule = ThinkGeo.MapSuite.Styles.LabelDuplicateRule.NoDuplicateLabels
        If type = "Vehicle" Then
            Me.BestPlacement = True
            Me.PointPlacement = ThinkGeo.MapSuite.Styles.PointPlacement.UpperRight
            Me.OverlappingRule = ThinkGeo.MapSuite.Styles.LabelOverlappingRule.NoOverlapping
        Else
            Me.BestPlacement = False
            Me.PointPlacement = ThinkGeo.MapSuite.Styles.PointPlacement.Center
            Me.OverlappingRule = ThinkGeo.MapSuite.Styles.LabelOverlappingRule.AllowOverlapping
        End If
    End Sub

    Public Overridable Function OnCreateMask() As AreaStyle
        If areastyle Then
            Dim aStyle As ThinkGeo.MapSuite.Styles.AreaStyle = New ThinkGeo.MapSuite.Styles.AreaStyle
            aStyle.FillSolidBrush = New GeoSolidBrush(GeoColor.FromArgb(255, 255, 255, 255))
            aStyle.OutlinePen = New GeoPen(GeoColor.StandardColors.Gray, 1.0)
            Return aStyle
        Else
            Return Nothing
        End If
    End Function

    Protected Overrides Sub DrawCore(features As IEnumerable(Of Feature), canvas As GeoCanvas, labelsInThisLayer As Collection(Of SimpleCandidate), labelsInAllLayers As Collection(Of SimpleCandidate))
        Try
            'If Type = "Vehicle" Then
            'Dim drawn_features = features.ToList.FindAll(Function(f As Feature) DirectCast(f.Tag, PxVehicle).Draw And DirectCast(f.Tag, PxVehicle).Focus).AsEnumerable
            MyBase.DrawCore(features, canvas, labelsInThisLayer, labelsInAllLayers)
            'Else
            'MyBase.DrawCore(features, canvas, labelsInThisLayer, labelsInAllLayers)
            'End If
        Catch ex As Exception
            'RadMessageBox.Show(ex.Message, projectName & " Information", MessageBoxButtons.OK, RadMessageIcon.Error)
            'errLog.WriteLog(ex.Message.ToString, Me.Name, System.Reflection.MethodBase.GetCurrentMethod().Name.ToString())
        End Try
    End Sub
End Class